Package: cellxgenedp
Title: Discover and Access Single Cell Data Sets in the CELLxGENE Data
        Portal
Version: 1.15.0
Authors@R: 
    c(person(
        given = "Martin",
        family = "Morgan",
        role = c("aut", "cre"),
        email = "mtmorgan.bioc@gmail.com",
        comment = c(ORCID = "0000-0002-5874-8148")
    ),
    person("Kayla", "Interdonato", role = "aut"))
Description: The cellxgene data portal
    (https://cellxgene.cziscience.com/) provides a graphical user
    interface to collections of single-cell sequence data processed in
    standard ways to 'count matrix' summaries. The cellxgenedp package
    provides an alternative, R-based inteface, allowind data
    discovery, viewing, and downloading.
License: Artistic-2.0
Encoding: UTF-8
Collate: db.R collections.R datasets.R files.R facets.R keys.R
        cellxgene.R utilities.R publisher_metadata.R cxg.R
Depends: R (>= 4.1.0), dplyr
Imports: httr, curl, utils, tools, cli, shiny, DT, rjsoncons
Suggests: zellkonverter, SingleCellExperiment, HDF5Array, tidyr,
        BiocStyle, knitr, rmarkdown, testthat (>= 3.0.0), mockery
biocViews: SingleCell, DataImport, ThirdPartyClient
URL: https://mtmorgan.github.io/cellxgenedp/,
        https://github.com/mtmorgan/cellxgenedp
BugReports: https://github.com/mtmorgan/cellxgenedp/issues
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
VignetteBuilder: knitr
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/cellxgenedp
git_branch: devel
git_last_commit: 844e4cf
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
NeedsCompilation: no
Packaged: 2025-10-30 20:28:51 UTC; biocbuild
Author: Martin Morgan [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-5874-8148>),
  Kayla Interdonato [aut]
Maintainer: Martin Morgan <mtmorgan.bioc@gmail.com>

#' @importFrom dplyr bind_rows mutate arrange desc
#'
#' @importFrom rjsoncons j_pivot
.db <-
    function(overwrite)
{
    path <- .cellxgene_cache_get(
        .COLLECTIONS, "collections", overwrite = overwrite
    )
    readLines(path) |>
        j_pivot(as = "tibble") |>
        bind_rows()
}

#' @importFrom cli cli_progress_bar cli_progress_update
#'     cli_progress_done
.db_detail <-
    function(collection_id, overwrite)
{
    n_collections <- length(collection_id)
    result <- vector("list", n_collections)
    cli_progress_bar("Collections", total = n_collections)
    for (i in seq_len(n_collections)) {
        ## be sure to return a result & check for errors
        result[[i]] <- tryCatch({
            uri <- paste0(.COLLECTIONS, collection_id[[i]])
            path <- .cellxgene_cache_get(uri, overwrite = overwrite)
            readLines(path)
        }, error = identity)
        cli_progress_update()
    }
    cli_progress_done()
    result
}

.db_first <- local({
    first <- TRUE
    function() {
        if (first && interactive()) {
            repeat {
                response <- readline("Update database and collections [yn]? ")
                response <- tolower(response)
                if (response %in% c("y", "n")) break
            }
            status <- identical(response, "y")
        } else {
            status <- FALSE
        }
        first <<- FALSE
        status
    }
})

#' @importFrom curl nslookup
.db_online <-
    function()
{
    response <- nslookup(.CELLXGENE_PRODUCTION_HOST, error = FALSE)
    !is.null(response)
}

#' @rdname db
#' @title Retrieve updated cellxgene database metadata
#'
#' @details The database is retrieved from the cellxgene data portal
#'     web site. 'collections' metadata are retrieved on each call;
#'     metadata on each collection is cached locally for re-use.
#'
#' @param overwrite logical(1) indicating whether the database of
#'     collections should be updated from the internet (the default,
#'     when internet is available and, in an interactive session, the
#'     user requests the update), or read from disk (assuming previous
#'     successful access to the internet).  `overwrite = FALSE` might
#'     be useful for reproducibility, testing, or when working in an
#'     environment with restricted internet access.
#'
#' @return `db()` returns an object of class 'cellxgene_db',
#'     summarizing available collections, datasets, and files.
#'
#' @examples
#' db()
#'
#' @export
db <-
    function(overwrite = .db_online() && .db_first())
{
    stopifnot(
        .is_scalar_logical(overwrite)
    )

    if (overwrite)
        message("updating database and collections...")
    db <- .db(overwrite)
    details <- .db_detail(db$collection_id, overwrite)
    errors <- vapply(details, inherits, logical(1), "error")
    if (any(errors)) {
        stop(
            sum(errors), " error(s) updating database; first error:\n",
            "  ", conditionMessage(details[[head(which(errors), 1L)]])
        )
    }
    details <- sprintf("[%s]", paste(details, collapse=","))

    class(details) <- c("cellxgene_db", class(details))
    details
}


#' @importFrom utils head
#'
#' @export
print.cellxgene_db <-
    function(x, ...)
{
    cat(
        head(class(x), 1L), "\n",
        "number of collections(): ", .jmes_to_r(x, "length([])"), "\n",
        "number of datasets(): ", .jmes_to_r(x, "length([].datasets[])"), "\n",
        "number of files(): ",
        .jmes_to_r(x, "length([].datasets[].assets[])"), "\n",
        sep = ""
    )
}

#' @rdname query
#'
#' @description `links()`, `authors()` and `publisher_metadata()` are
#'     helper functions to extract 'nested' information from
#'     collections.
#'
#' @return `links()` returns a tibble of external links associated
#'     with each collection. Common links includ DOI, raw data / data
#'     sources, and lab websites.
#'
#' @examples
#' ## common links to external data
#' links(db) |>
#'     dplyr::count(link_type)
#'
#' @export
links <-
    function(cellxgene_db = db())
{
    link_lengths <-
        .jmes_to_r(cellxgene_db, "[*].length(links)[]")
    collection_ids <- .jmes_to_r(cellxgene_db, "[*].collection_id")
    collection_id <- tibble(collection_id = rep(collection_ids, link_lengths))
    links <-
        cellxgene_db |>
        .jmes_to_r("[*].links[*]") |>
        ## create a single tibble
        bind_rows() |>
        as_tibble() |>
        ## clean up unnamed links from '""' to NA
        mutate(
            link_name = ifelse(
                nzchar(.data$link_name), .data$link_name, NA_character_
            )
        )

    bind_cols(collection_id, links)
}

#' @rdname query
#'
#' @return `authors()` returns a tibble of authors associated with
#'     each collection.
#'
#' @examples
#' ## authors per collection
#' authors() |>
#'     dplyr::count(collection_id, sort = TRUE)
#'
#' @importFrom dplyr rename
#'
#' @export
authors <-
    function(cellxgene_db = db())
{
    ## publisher_metadata can be NULL; filter for non-null values
    cellxgene_db <- j_query(cellxgene_db, "[?not_null(publisher_metadata)]")

    author_length <-
        .jmes_to_r(cellxgene_db, "[*].publisher_metadata[].length(authors)")
    author <-
        .jmes_to_r(cellxgene_db, "[*].publisher_metadata[].authors[]") |>
        bind_rows() |>
        as_tibble() |>
        rename(consortium = "name")

    collection_ids <- .jmes_to_r(cellxgene_db, "[*].collection_id")
    collection_id <- rep(collection_ids, author_length)
    bind_cols(
        tibble(collection_id = collection_id),
        author
    )
}

#' @rdname query
#'
#' @return `publisher_metadata()` returns a tibble of publisher
#'     metadata (journal, publicate date, doi) associated with each
#'     collection.
#'
#' @examples
#' publisher_metadata() |>
#'     dplyr::glimpse()
#'
#' @export
publisher_metadata <-
    function(cellxgene_db = db())
{
    ## publisher_metadata can be NULL; filter for non-null values
    cellxgene_db <- j_query(cellxgene_db, "[?not_null(publisher_metadata)]")

    keys <- c(
        "is_preprint", "journal",
        paste("published", c("at", "year", "month", "day"), sep = "_")
    )
    publisher_metadata_path <- paste0(
        "[*].publisher_metadata.{",
        paste(keys, keys, sep = ": ", collapse = ", "),
        "}"
    )

    publisher_metadata <-
        .jmes_to_r(cellxgene_db, publisher_metadata_path) |>
        bind_rows() |>
        as_tibble() |>
        mutate(
            published_at = as.Date(as.POSIXct(
                .data$published_at, origin = "1970-01-01 00:00.00 UTC"
            ))
        )

    collection_id <- .jmes_to_r(cellxgene_db, "[*].collection_id")
    name <- .jmes_to_r(cellxgene_db, "[*].name")
    publisher_metadata <- bind_cols(
        tibble(collection_id = collection_id, name = name),
        publisher_metadata
    )

    doi <-
        links() |>
        filter(.data$link_type == "DOI") |>
        select(collection_id, doi = "link_url")

    left_join(publisher_metadata, doi, by = "collection_id")
}

test_that("links() works", {
    db_exists <- tryCatch({ db(); TRUE }, error = isTRUE)
    skip_if_not(db_exists)

    links <- links()
    expect_true(nrow(links) >= 549L)

    link_types <- c(
        "DATA_SOURCE", "LAB_WEBSITE", "OTHER", "PROTOCOL", "RAW_DATA"
    )
    expect_true(all(link_types %in% unique(pull(links, "link_type"))))

    ## used in vignette
    doi_of_interest <- "https://doi.org/10.1016/j.stem.2018.12.011"
    rows_of_interest <-
        links |>
        filter(link_url == doi_of_interest) |>
        nrow()
    expect_identical(rows_of_interest, 1L)
})

test_that("authors() works", {
    db_exists <- tryCatch({ db(); TRUE }, error = isTRUE)
    skip_if_not(db_exists)

    authors <- authors()
    expect_true(nrow(authors) >= 3571L)

    ## used in vignette
    collection_id_of_interest <- "c9706a92-0e5f-46c1-96d8-20e42467f287"
    rows_of_interest <-
        authors |>
        filter(collection_id == collection_id_of_interest) |>
        nrow()
    expect_identical(rows_of_interest, 12L)
})

test_that("publisher_metadata() works", {
    db_exists <- tryCatch({ db(); TRUE }, error = isTRUE)
    skip_if_not(db_exists)

    publisher_metadata <- publisher_metadata()
    expect_true(nrow(publisher_metadata) >= 113L)

    ## used in vignette
    collection_id_of_interest <- "c9706a92-0e5f-46c1-96d8-20e42467f287"
    rows_of_interest <-
        publisher_metadata |>
        filter(collection_id == collection_id_of_interest)
    expect_identical(nrow(rows_of_interest), 1L)
})

#' @rdname query
#'
#' @examples
#' files(db) |>
#'     dplyr::glimpse()
#'
#' @export
files <-
    function(cellxgene_db = db())
{
    dataset_ids <- .jmes_to_r(cellxgene_db, "[].datasets[].dataset_id")
    files_per_dataset <- .jmes_to_r(
        cellxgene_db, "[].datasets[].length(assets)"
    )
    files <- .keys_query(cellxgene_db, "[].datasets[].assets[]", "files")
    bind_cols(
        dataset_id = rep(dataset_ids, files_per_dataset),
        files
    )
}

.file_download <-
    function(dataset_id, file_type, url, dry.run, cache.path)
{
    file_name <- basename(url)
    if (dry.run) {
        message(
            "'files_download(dry.run = TRUE)'\n",
            "  file_name: ", file_name, "\n"
        )
        return(file_name)
    }

    ## download
    .cellxgene_cache_get(
        url, file_name, progress = interactive(), cache_path = cache.path
    )
}

#' @rdname query
#'
#' @description `files_download()` retrieves one or more cellxgene
#'     files to a cache on the local system.
#'
#' @param dry.run logical(1) indicating whether the (often large)
#'     file(s) in `tbl` should be downloaded to a local cache. Files
#'     are not downloaded when `dry.run = TRUE` (default).
#'
#' @param cache.path character(1) directory in which to cache
#'     downloaded files. The directory must already exist. The default
#'     is `tools::R_user_dir("cellxgenedp", "cache")`, a
#'     package-specific path in the user home directory.
#'
#' @return `files_download()` returns a character() vector of paths to
#'     the local files.
#'
#' @examples
#' \dontrun{
#' files(db) |>
#'     dplyr::slice(1) |>
#'     files_download(dry.run = FALSE)
#' }
#'
#' @export
files_download <-
    function(tbl, dry.run = TRUE, cache.path = .cellxgene_cache_path())
{
    stopifnot(
        all(c("dataset_id", "filetype", "url") %in% colnames(tbl)),
        .is_scalar_logical(dry.run),
        .is_scalar_character(cache.path), dir.exists(cache.path)
    )

    result <- Map(
        .file_download,
        pull(tbl, "dataset_id"), pull(tbl, "filetype"), pull(tbl, "url"),
        MoreArgs = list(dry.run = dry.run, cache.path = cache.path)
    )

    if (identical(length(result), 0L)) {
        result <- character()
        names(result) <- character()
    } else {
        result <- unlist(result)
    }
    result
}

test_that("files() works", {
    db_exists <- tryCatch({ db(); TRUE }, error = isTRUE)
    skip_if_not(db_exists)

    files <- files()

    FILES_COLUMNS <- c(
        dataset_id = "character",
        filesize = "numeric",
        filetype = "character",
        url = "character"
    )
    column_names <- names(FILES_COLUMNS)
    expect_true(all(column_names %in% names(files)))
    columns <- vapply(files[column_names], class, character(1))
    expect_identical(columns, FILES_COLUMNS)
})

test_that("files_download() works", {
    ## mockery does not appear to support applying two stubs to one function
    skip("files_download() not tested due to mockery limitation")
    db_exists <- tryCatch({ db(); TRUE }, error = isTRUE)
    skip_if_not(db_exists)

    files <- files() |> head(2)
    mockery::stub(
        files_download,
        ".file_presigned_url",
        identity
    )
    mockery::stub(
        files_download,
        ".cellxgene_cache_get",
        function(x, y, progress) { names(x) <- y; x }
    )
    object <- files_download(files, dry.run = FALSE)

    expected <- with(files, paste0(.DATASETS, dataset_id, "/asset/", file_id))
    names(expected) <- with(
        files, paste0(dataset_id, ".", file_id, ".", filetype)
    )
    expect_identical(object, expected)
})

test_that("files_download() returns named character vector on 0 inputs", {
    tbl <- data.frame(
        dataset_id = character(), filetype = character(), url = character()
    )
    expect_identical(files_download(tbl), setNames(character(), character()))
})

test_that("files_download() pays attention to cache.path", {
    tbl <- data.frame(
        dataset_id = character(), filetype = character(), url = character()
    )
    cache_path <- tempfile()
    ## directory does not exist
    expect_error(files_download(tbl, cache.path = cache_path))
    dir.create(cache_path)
    expect_identical(
        files_download(tbl, cache.path = cache_path),
        setNames(character(), character())
    )
})

#' @rdname query
#' @title Query cellxgene collections, datasets, and files
#'
#' @param cellxgene_db an optional 'cellxgene_db' object, as returned
#'     by `db()`.
#'
#' @return Each function returns a tibble describing the corresponding
#'     component of the database.
#'
#' @examples
#' db <- db()
#'
#' collections(db)
#'
#' collections(db) |>
#'     dplyr::glimpse()
#'
#' @export
collections <-
    function(cellxgene_db = db())
{
    .keys_query(cellxgene_db, "[]", "collections")
}

test_that("collections() works", {
    db_exists <- tryCatch({ db(); TRUE }, error = isTRUE)
    skip_if_not(db_exists)

    collections <- collections()
    expect_true(nrow(collections) >= 48L)
    COLLECTIONS_COLUMNS <- c(
        collection_id="character",
        collection_version_id = "character",
        collection_url = "character",
        consortia = "list",
        contact_email="character",
        contact_name="character",
        curator_name="character",
        description="character",
        doi = "character",
        links="list",
        name="character",
        publisher_metadata = "list",
        revising_in = "logical",
        revision_of = "logical",
        visibility="character",
        created_at="Date",
        published_at="Date"
    )
    column_names <- names(COLLECTIONS_COLUMNS)
    expect_true(all(column_names %in% names(collections)))
    classes <- vapply(collections[column_names], class, character(1))
    expect_identical(classes, COLLECTIONS_COLUMNS)
})

#' @importFrom dplyr relocate
#' @rdname query
#'
#' @examples
#' datasets(db) |>
#'     dplyr::glimpse()
#'
#' @export
datasets <-
    function(cellxgene_db = db())
{
    collection_ids <- .jmes_to_r(cellxgene_db, "[].collection_id")
    datasets_per_collection <- .jmes_to_r(cellxgene_db, "[].length(datasets)")
    datasets <- .keys_query(cellxgene_db, "[].datasets[]", "datasets")
    datasets |>
        bind_cols(
            collection_id = rep(collection_ids, datasets_per_collection)
        ) |>
        relocate(
            "dataset_id", "dataset_version_id", "collection_id",
            everything()
        )
}

#' @importFrom utils browseURL
#' @importFrom dplyr distinct pull
#' @rdname query
#'
#' @param tbl a `tibble()` typically derived from `datasets(db)` or
#'     `files(db)` and containing columns `dataset_id` (for
#'     `datasets_visualize()`), or columns `dataset_id`, `file_id`,
#'     and `filetype` (for `files_download()`).
#'
#' @examples
#' \donttest{
#' if (interactive()) {
#'     ## visualize the first dataset
#'     datasets(db) |>
#'         dplyr::slice(1) |>
#'         datasets_visualize()
#' }
#' }
#' @export
datasets_visualize <-
    function(tbl)
{
    stopifnot(
        "dataset_id" %in% names(tbl)
    )

    dataset_ids <-
        tbl |>
        select(dataset_id) |>
        distinct() |>
        pull("dataset_id")
    if (length(dataset_ids) > 5L)
        stop("'visualize()' only allows up to 5 datasets per call")

    for (dataset_id in dataset_ids) {
        url <- paste0(.CELLXGENE_EXPLORER, dataset_id, ".cxg/")
        browseURL(url)
    }
}

test_that("datasets() works", {
    db_exists <- tryCatch({ db(); TRUE }, error = isTRUE)
    skip_if_not(db_exists)

    datasets <- datasets()
    expect_true(nrow(datasets) >= 223L)
    DATASETS_COLUMNS <- c(
        dataset_id = "character",
        dataset_version_id = "character",
        collection_id = "character",
        donor_id = "list",
        assay = "list",
        batch_condition = "list",
        cell_count = "integer",
        cell_type = "list",
        development_stage = "list",
        disease = "list",
        explorer_url = "character",
        is_primary_data = "list",
        mean_genes_per_cell = "numeric",
        organism = "list",
        schema_version = "character",
        self_reported_ethnicity = "list",
        sex = "list",
        suspension_type = "list",
        tissue = "list", title = "character",
        tombstone = "logical",
        x_approximate_distribution = "character",
        published_at = "Date",
        revised_at = "Date"
    )
    column_names <- names(DATASETS_COLUMNS)
    expect_true(all(column_names %in% names(datasets)))
    columns <- vapply(datasets[column_names], class, character(1))
    expect_identical(columns, DATASETS_COLUMNS)
})

test_that("datasets_visualize() works", {
    db_exists <- tryCatch({ db(); TRUE }, error = isTRUE)
    skip_if_not(db_exists)

    datasets <-
        datasets() |>
        head(2)

    object <- NULL
    mockery::stub(datasets_visualize, "browseURL", \(x) object <<- c(object, x))
    datasets_visualize(datasets)

    expected <- paste0(.CELLXGENE_EXPLORER, datasets$dataset_id, ".cxg/")
    expect_identical(object, expected)
})

.timestamp_to_date <-
    function(x)
{
    as.Date(as.POSIXct(x, origin = "1970-01-01"))
}

.is_scalar <-
    function(x)
{
    length(x) == 1L && !is.na(x)
}

.is_scalar_character <-
    function(x)
{
    .is_scalar(x) && is.character(x) && nzchar(x)
}

.is_scalar_logical <-
    function(x)
{
    .is_scalar(x) && is.logical(x)
}

#' @importFrom rjsoncons j_query
.jmes_to_r <-
    function(db, path, ..., simplifyVector = TRUE)
{
    j_query(db, path, as = "R")
}

.onLoad <-
    function(libname, pkgname)
{
    ## reset the cache once a week on the builders
    if (identical(Sys.getenv("IS_BIOC_BUILD_MACHINE"), "true")) {
        cache_path <- .cellxgene_cache_path()
        if (dir.exists(cache_path)) {
            creation_time <-  file.info(cache_path, extra_cols = FALSE)$ctime
            age <- difftime(Sys.Date(), creation_time, units = "days")
            if (age > 7) {
                unlink(cache_path, recursive = TRUE, force =  TRUE)
            }
        }
    }
}

.wrap <-
    function(...)
{
    x <- paste0(...)
    paste(strwrap(x), collapse = "\n")
}

.onAttach <-
    function(libname, pkgname)
{
    packageStartupMessage(.wrap(
        "The interface to CELLxGENE has changed; versions of ",
        "cellxgenedp prior to 1.4.1 / 1.5.2 will cease to work when ",
        "CELLxGENE removes the previous interface. See the section ",
        "'API changes' of the 'Discover and download datasets...' ",
        "vignette for important details."
    ))
}

test_that(".timestamp_to_date() works", {
    origin <- as.Date("1970-01-01")
    expect_identical(.timestamp_to_date(integer()), as.Date(character()))
    expect_identical(.timestamp_to_date(0L), origin)
    expect_identical(.timestamp_to_date(rep(0L, 2L)), rep(origin, 2L))
})

test_that(".is_scalar() works", {
    expect_true(.is_scalar_character("a"))
    expect_false(.is_scalar_character(character()))
    expect_false(.is_scalar_character(integer(1)))
    expect_false(.is_scalar_character(""))
    expect_false(.is_scalar_character(letters))
    expect_false(.is_scalar_character(NA_character_))
})

## package-global variables

.CELLXGENE_PRODUCTION_HOST <- "api.cellxgene.cziscience.com"

.CELLXGENE_PRODUCTION_ENDPOINT <- paste0("https://", .CELLXGENE_PRODUCTION_HOST)

.DATASETS <- paste0(.CELLXGENE_PRODUCTION_ENDPOINT, "/curation/v1/datasets/")

.COLLECTIONS <- paste0(.CELLXGENE_PRODUCTION_ENDPOINT, "/curation/v1/collections/")

.CELLXGENE_EXPLORER <- "https://cellxgene.cziscience.com/e/"

#' @importFrom httr GET write_disk progress status_code
#'     stop_for_status content headers
.cellxgene_GET <-
    function(uri)
{
    response <- GET(uri)
    stop_for_status(response)
    response
}

## for testing purposes
.cellxgene_HEAD <-
    function(uri)
{
    response <- httr::HEAD(uri)
    stop_for_status(response)
    response
}

#' @importFrom tools R_user_dir
.cellxgene_cache_path <-
    function(base_path = R_user_dir("cellxgenedp", "cache"))
{
    path <- file.path(base_path, "curation", "v1")
    if (!dir.exists(path))
        dir.create(path, recursive = TRUE)
    path
}

#' @importFrom tools file_path_sans_ext
#'
#' @importFrom dplyr as_tibble .data
.cellxgene_cache_annotate <-
    function(cellxgene_db = db())
{
    path <- .cellxgene_cache_path()
    info <-
        file.info(dir(path, full.names = TRUE)) |>
        as_tibble(rownames = "path") |>
        mutate(file = basename(path)) |>
        select(-c("isdir", "mode"))

    collections <- collections(cellxgene_db)
    files <- files(cellxgene_db)
    info |>
        mutate(
            type = ifelse(file == "collections", "collections", NA_character_),
            type = ifelse(
                file %in% collections$collection_id, "collection", .data$type
            ),
            type = ifelse(
                file_path_sans_ext(file) %in% files$file_id, "file", .data$type
            )
        ) |>
        select("file", "type", everything())
}

.cellxgene_cache_get <-
    function(
        uri, file = basename(uri), progress = FALSE, overwrite = FALSE,
        cache_path = .cellxgene_cache_path())
{
    path <- file.path(cache_path, file)
    if (overwrite || !file.exists(path)) {
        ## download to path0 and then copy / unlink to path to avoid
        ## overwriting file with failed attempt. Don't use
        ## file.rename() since this will fail when tempfile() and
        ## cache are on separate file systems.
        path0 <- tempfile()
        response <- GET(
            uri,
            if (progress) progress(),
            write_disk(path0, overwrite = overwrite)
        )
        if (status_code(response) >= 400L) {
            unlink(path0)
            stop_for_status(response)
        }
        success <- file.copy(path0, path, overwrite = TRUE)
        if (!success) {
            stop(
                "failed to copy uri from local path to cache.\n",
                "  uri: '", uri, "\n",
                "  local path: ", path0, "\n",
                "  cache path: ", path
            )
        }
        unlink(path0)
    }
    path
}

test_that("endpoints exist", {
    expect_true(nzchar(.CELLXGENE_PRODUCTION_HOST))
    expect_true(nzchar(.CELLXGENE_PRODUCTION_ENDPOINT))
    expect_true(nzchar(.DATASETS))
    expect_true(nzchar(.COLLECTIONS))
    expect_true(nzchar(.CELLXGENE_EXPLORER))

    skip_if_offline(.CELLXGENE_PRODUCTION_HOST)
    expect_identical(status_code(.cellxgene_HEAD(.COLLECTIONS)), 200L)
    expect_identical(status_code(.cellxgene_HEAD(.DATASETS)), 200L)
})

test_that(".cellxgene_cache_path() works", {
    expect_true(dir.exists(.cellxgene_cache_path(tempfile())))

    ## don't create cache if it does not exist
    cache_path <- file.path(
        R_user_dir("cellxgenedp", "cache"), "curation", "v1"
    )
    skip_if(!dir.exists(cache_path))
    expect_identical(.cellxgene_cache_path(), cache_path)
})

test_that(".cellxgene_cache_get() works from existing cache", {
    cache_path <- file.path(
        R_user_dir("cellxgenedp", "cache"), "curation", "v1"
    )
    collections <- file.path(cache_path, "collections")

    skip_if(!file.exists(collections))
    expect_identical(.cellxgene_cache_get(file = "collections"), collections)
})

test_that(".cellxgene_cache_get() works online", {
    skip_if_offline(.CELLXGENE_PRODUCTION_HOST)
    cache_path <- tempfile(); dir.create(cache_path)
    expect_identical(
        .cellxgene_cache_get(.COLLECTIONS, cache_path = cache_path),
        file.path(cache_path, "collections")
    )
})

#' @importFrom dplyr filter slice summarize left_join
#'
#' @importFrom shiny actionButton hr icon navbarPage observeEvent
#'     renderText runGadget stopApp tabPanel textOutput
#'     updateNavbarPage
#'
#' @importFrom DT renderDataTable datatable formatStyle

##
## utilities
##

.cxg_download_cache <- local({
    files <- new.env(parent = emptyenv())
    list(reset = function() {
        rm(list = ls(files), envir = files)
    }, toggle = function(id) {
        if (exists(id, envir = files)) {
            rm(list = id, envir = files)
        } else {
            assign(id, TRUE, envir = files)
        }
    }, ls = function() {
        ls(files)
    })
})

.cxg_labels <-
    function(x)
{
    vapply(x, function(elt) {
        labels <- vapply(elt, `[[`, character(1), "label")
        paste(labels, collapse = ", ")
    }, character(1))
}

## collections() / datasets() / files()

.cxg_collections <-
    function(db)
{
    collections <- collections(db) |>
        select(c("collection_id", "name"))

    datasets <-
        datasets(db) |>
        select(
            "collection_id", "tissue", "assay", "disease", "organism",
            "cell_count"
        )

    labeledDat <-
        datasets |>
        mutate(
            across(c("tissue", "assay", "disease", "organism"), .cxg_labels)
        ) |>
        group_by(.data$collection_id) |>
        summarize(across(
            c("tissue", "assay", "disease", "organism"),
            function(x) paste(unique(x), collapse = ", ")
        ))

    countDat <- datasets |>
        group_by(.data$collection_id) |>
        summarize(cell_count = sum(.data$cell_count))

    allDat <-
        left_join(collections, labeledDat, by = "collection_id") |>
        left_join(countDat, by = "collection_id")

    allDat
}

.cxg_datasets <-
    function(db)
{
    ## select tbl
    datasets(db) |>
        mutate(
            across(c("tissue", "assay", "disease", "organism"), .cxg_labels),
            view = as.character(icon("eye-open", lib = "glyphicon"))
        ) |>
        select(
            "dataset_id", "collection_id", "view", "title", "tissue", "assay",
            "disease", "organism", "cell_count"
        )
}

.cxg_files <-
    function(db, id)
{
    tbl <- files(db)

    if (!is.null(id))
        tbl <- tbl |> dplyr::filter(.data$dataset_id == id)
    tbl
}

## *_format() for display

.cxg_collections_format <-
    function(tbl)
{
    dt <- datatable(
        tbl,
        selection = 'single',
        filter = 'top',
        colnames = c(
            'rownames', 'id', 'Collection', 'Tissue', 'Assay',
            'Disease', 'Organism', 'Cells'
        ),
        options = list(
            scrollY = 400,
            columnDefs = list(
                list(visible = FALSE, targets = 0:1),
                list(width = '20px', targets = 4:7)
            )
        )
    )
    formatStyle(dt, 2:7, 'vertical-align' = 'top')
}

.cxg_datasets_format <-
    function(tbl)
{
    dt <- datatable(
        tbl,
        selection = 'multiple',
        filter = 'top',
        escape = FALSE,
        colnames = c(
            'rownames', 'dataset_id', 'collection_id', 'View', 'Dataset',
            'Tissue', 'Assay', 'Disease', 'Organism',
            'Cells'
        ),
        options = list(
            scrollX = TRUE,
            scrollY = 400,
            columnDefs = list(
                list(visible = FALSE, targets = 0:2),
                list(className = 'dt-center', width = "10px", targets = 3)
            )
        )
    )
    formatStyle(dt, 3:9, 'vertical-align' = "top")

}

## download helpers

.cxg_download <-
    function(dataset_ids, convert)
{
    if (!length(dataset_ids))
        return(character(0))

    message(
        "Downloading ", if (convert) "& converting ",
        length(dataset_ids), " datasets"
    )
    db <- db(overwrite = FALSE)
    files(db) |>
        filter(
            .data$dataset_id %in% dataset_ids,
            .data$filetype == "H5AD"
        ) |>
        files_download(dry.run = FALSE)
}

.cxg_as_tibble <-
    function(dataset_ids, local_paths)
{
    db <- db(overwrite = FALSE)
    x <- tibble(dataset_id = dataset_ids, local_path = local_paths)
    left_join(x, datasets(db), by = "dataset_id")
}

#' @importFrom utils installed.packages
.cxg_sce_validate_software_requirements <-
    function()
{
    pkgs <- c("SingleCellExperiment", "zellkonverter", "HDF5Array")
    need <- setdiff(pkgs, rownames(installed.packages()))
    if (length(need)) {
        need <- paste(need, collapse = '", "')
        stop(
            "'cxg(as = \"sce\")' requires additional packages; use\n",
            "    BiocManager::install(c(\"", need, "\"))"
        )
    }
}

.cxg_sce <-
    function(dataset_ids, local_paths)
{
    lapply(local_paths, function(local_path) {
        message("Converting ", basename(local_path))
        zellkonverter::readH5AD(local_path, reader = "R", use_hdf5 = TRUE)
    })
}

##
## ui / server / app
##

.cxg_ui <-
    function()
{
    navbarPage(
        'cellxgenedp',

        tabPanel(
            "Datasets",
            textOutput("datasets_selected", inline = TRUE),
            actionButton("quit_and_download", "Quit and download"),
            actionButton("quit", "Quit"),
            hr(),
            DT::dataTableOutput("datasets")
        ),
        tabPanel(
            "Collections",
            DT::dataTableOutput("collections")
        ),

        id = "navbar"

    )
}

.cxg_server <-
    function(input, output, session)
{
    db <- db(overwrite = FALSE)
    collections <- .cxg_collections(db)
    datasets <- .cxg_datasets(db)
    dataset <- datasets # current dataset(s)
    files <- .cxg_files(db, id = NULL)

    output$datasets_selected <- renderText({
        paste(
            "Datasets selected:",
            length(.cxg_download_cache$ls())
        )
    })

    output$collections <- DT::renderDataTable({
        .cxg_collections_format(collections)
    })

    output$datasets <- DT::renderDataTable({
        .cxg_datasets_format(dataset)
    })

    observeEvent(input$collections_cell_clicked, {
        info <- input$collections_cell_clicked
        if (is.null(info$value))
            return()
        row_idx <- input$collections_row_last_clicked
        id <- collections[row_idx, "collection_id"][[1]]
        dataset <<- datasets |> dplyr::filter(.data$collection_id %in% id)
        output$datasets <- DT::renderDataTable(.cxg_datasets_format(dataset))
        updateNavbarPage(session, 'navbar', selected = 'Datasets')
    })

    observeEvent(input$datasets_cell_clicked, {
        info <- input$datasets_cell_clicked
        if (is.null(info$value))
            return()
        id <- dataset[input$datasets_row_last_clicked, "dataset_id"][[1]]

        if (info$col == 3) {
            files <<- .cxg_files(db, id)
            files |>
                ## filter(.data$filetype == "CXG") |>
                slice(1) |>
                datasets_visualize()
        }

        ## all selections, including `info$col == 3` toggle download status
        .cxg_download_cache$toggle(id)
        output$datasets_selected <- renderText({
            paste(
                "Datasets selected:",
                length(.cxg_download_cache$ls())
            )
        })
    })

    ## quit

    observeEvent(input$quit_and_download, {
        ids <- .cxg_download_cache$ls()
        stopApp(ids)
    })

    observeEvent(input$quit, {
        stopApp(character(0))
    })
}

#' @name cxg
#' @title Shiny application for discovering, viewing, and downloading
#'     cellxgene data
#'
#' @param as character(1) Return value when quiting the shiny
#'     application. `"tibble"` returns a tibble describing selected
#'     datasets (including the location on disk of the downloaded
#'     file). `"sce"` returns a list of dataset files imported to R as
#'     SingleCellExperiment objects.
#'
#' @return `cxg()` returns either a tibble describing datasets
#'     selected in the shiny application, or a list of datasets
#'     imported into R as SingleCellExperiment objects.
#'
#' @examples
#' \donttest{
#' if (interactive())
#'     cxg()
#' }
#'
#' @export
cxg <-
    function(as = c('tibble', 'sce'))
{
    as <- match.arg(as)
    if (identical(as, "sce"))
        .cxg_sce_validate_software_requirements()

    .cxg_download_cache$reset()
    dataset_ids <- runGadget(.cxg_ui(), .cxg_server)
    local_paths <- .cxg_download(dataset_ids, identical(as, "sce"))

    switch(
        as,
        tibble = .cxg_as_tibble(dataset_ids, local_paths),
        sce = .cxg_sce(dataset_ids, local_paths)
    )
}

.KEYS_BLOCKLIST <- c("datasets", "assets")

.keys <-
    function(db, query_base, keys, path)
{
    query <- paste0(query_base, ".keys(@)")
    key_names <-
        .jmes_to_r(db, query) |>
        unlist() |>
        sort() |>
        setdiff(.KEYS_BLOCKLIST)
    key_paths <- paste0(query_base, ".", key_names)
    names(key_paths) <- key_names
    key_paths
}

#' @importFrom dplyr select across ends_with last_col everything
keys <-
    function(cellxgene_db = db())
{
    queries <- c(
        collections = "[]",
        datasets = "[].datasets[]",
        files = "[].datasets[].assets[]"
    )
    lapply(queries, .keys, db = cellxgene_db)
}

.keys_query <-
    function(db, prefix, key)
{
    stopifnot(
        inherits(db, "cellxgene_db"),
        .is_scalar_character(prefix),
        .is_scalar_character(key)
    )
    keys <- names(keys(db)[[key]])

    ## query -- prefix.{...} ensures all rows have all keys
    query <- paste0(
        prefix, ".{",
        paste0(keys, ":", keys, collapse = ","),
        "}"
    )
    lol <- .jmes_to_r(db, query, simplifyVector = FALSE)

    ## list-of-rows to list-of-columns
    keys <- names(lol[[1]])
    names(keys) <- keys
    lol <- lapply(keys, \(x) lapply(lol, `[[`, x))
    tbl <- do.call(tibble, lol)

    ## list(NULL) -> NA
    tbl[] <- lapply(tbl, \(x) {
        idx <- lengths(x) == 0L
        x[idx] <- NA
        x
    })

    ## unbox list columns where all entries are length 1
    idx <- vapply(tbl, \(x) all(lengths(x) == 1L), logical(1))
    idx[names(idx) %in% FACETS] <- FALSE # don't unbox facets
    tbl[idx] <- lapply(tbl[idx], unlist)

    ## timestamps to Date
    tbl <-
        tbl |>
        mutate(across(ends_with("_at"), .timestamp_to_date))

    ## format
    result <-
        tbl |>
        relocate(ends_with("_id"), everything()) |>
        relocate(ends_with("_at"), .after = last_col())

    ## class
    subclass <- paste0("cellxgene_keys_", key)
    class(result) <- c(subclass, "cellxgene_keys", class(result))

    result
}

test_that("keys() works", {
    db_exists <- tryCatch({ db(); TRUE }, error = isTRUE)
    skip_if_not(db_exists)

    keys <- keys()
    expected <- c(collections = 18L, datasets = 23L, files = 3L)
    expect_true(all(lengths(keys) >= expected))
})

#' @rdname facets
#' @title Facets available for querying cellxgene data
#'
#' @description `FACETS` is a character vector of common fields used
#'     to subset cellxgene data.
#'
#' @format `FACETS` is an object of class `character` of length 8.
#'
#' @export
FACETS <- c(
    "assay", "cell_type", "development_stage", "disease",
    "self_reported_ethnicity", "organism", "sex", "tissue"
)

.facet <-
    function(cellxgene_db, facet)
{

    query <- sprintf(
        "[].datasets[].%s[*].{
            label: label, ontology_term_id: ontology_term_id
        }[]",
        facet
    )
    projection <-
        cellxgene_db |>
        .jmes_to_r(query)

    projection |>
        bind_rows() |>
        group_by(.data$label, .data$ontology_term_id) |>
        count(sort = TRUE) |>
        ungroup() |>
        bind_cols(tibble(facet))
}

#' @importFrom dplyr group_by ungroup count bind_cols tibble .data
#'
#' @rdname facets
#'
#' @description `facets()` is used to query the cellxgene database for
#'     current values of one or all facets.
#'
#' @param cellxgene_db an (optional) cellxgene_db object, as returned
#'     by `db()`.
#'
#' @param facets a character() vector corersponding to one of the
#'     facets in `FACETS`.
#'
#' @return `facets()` returns a tibble with columns `facet`, `label`,
#'     `ontology_term_id`, and `n`, the number of times the facet
#'     label is used in the database.
#'
#' @examples
#' f <- facets()
#'
#' ## levels of each facet
#' f |>
#'     dplyr::count(facet)
#'
#' ## same as facets(, facets = "organism")
#' f |>
#'     dplyr::filter(facet == "organism")
#'
#' @export
facets <-
    function(cellxgene_db = db(), facets = FACETS)
{
    stopifnot(
        inherits(cellxgene_db, "cellxgene_db"),
        all(facets %in% FACETS)
    )

    terms <- lapply(facets, .facet, cellxgene_db = cellxgene_db)

    terms |>
        bind_rows() |>
        select("facet", "label", "ontology_term_id", "n")
}

#' @rdname facets
#'
#' @description `facets_filter()` provides a convenient way to filter
#'     facets based on label or ontology term.
#'
#' @param facet the column containing faceted information, e.g., `sex`
#'     in `datasets(db)`.
#'
#' @param key character(1) identifying whether `value` is a `label` or
#'     `ontology_term_id`.
#'
#' @param value character() value of the label or ontology term to
#'     filter on. The value may be a vector with `length(value) > 0`
#'     for exact matchs (`exact = TRUE`, default), or a `character(1)`
#'     regular expression.
#'
#' @param exact logical(1) whether values match exactly (default,
#'     `TRUE`) or as a regular expression (`FALSE`).
#'
#' @return `facets_filter()` returns a logical vector with length
#'     equal to the length (number of rows) of `facet`, with `TRUE`
#'     indicating that the `value` of `key` is present in the dataset.
#'
#' @examples
#' db <- db()
#' ds <- datasets(db)
#'
#' ## datasets with African American females
#' ds |>
#'     dplyr::filter(
#'         facets_filter(self_reported_ethnicity, "label", "African American"),
#'         facets_filter(sex, "label", "female")
#'     )
#'
#' ## datasets with non-European, known ethnicity
#' facets(db, "self_reported_ethnicity")
#' ds |>
#'     dplyr::filter(
#'         !facets_filter(
#'             self_reported_ethnicity, "label", c("European", "na", "unknown")
#'         )
#'     )
#'
#' @export
facets_filter <-
    function(facet, key = c("label", "ontology_term_id"), value, exact = TRUE)
{
    key <- match.arg(key)
    stopifnot(
        (exact && is.character(value)) ||
            (!exact && .is_scalar_character(value)),
        .is_scalar_logical(exact)
    )

    row_index <- rep(seq_along(facet), lengths(facet))
    facet_kv <- unlist(facet, recursive = FALSE, use.names = FALSE)
    values <- vapply(facet_kv, `[[`, character(1), key)
    if (exact) {
        found_index <- row_index[values %in% value]
    } else {
        found_index <- row_index[grepl(value, values)]
    }
    seq_along(facet) %in% found_index
}

test_that("facets() works", {
    db_exists <- tryCatch({ db(); TRUE }, error = isTRUE)
    skip_if_not(db_exists)

    facets <- facets()
    expect_true(nrow(facets) >= 743L)
    FACETS_COLUMNS <- c(
        facet="character", label="character", ontology_term_id="character",
        n="integer"
    )
    columns <- vapply(facets, class, character(1))
    expect_identical(columns, FACETS_COLUMNS)
    expect_identical(dim(count(facets, facet)), c(8L, 2L))
})

test_that("facets_filter() works", {
    db_exists <- tryCatch({ db(); TRUE }, error = isTRUE)
    skip_if_not(db_exists)

    dataset <- structure(
        list(
            id = 1:2,
            sex=list(
                list(
                    list(label = "female", ontology_term_id = "PATO:0000383"), 
                    list(label = "male", ontology_term_id = "PATO:0000384")
                ), 
                list(
                    list(label = "female", ontology_term_id = "PATO:0000383"), 
                    list(label = "male", ontology_term_id = "PATO:0000384"), 
                    list(label = "unknown", ontology_term_id = "unknown")
                )
            )
        ),
        row.names = c(NA, -2L),
        class = c(
            "cellxgene_keys_datasets", "cellxgene_keys", "tbl_df", "tbl",
            "data.frame"
        )
    )

    object <- dplyr::filter(dataset, facets_filter(sex, "label", "unknown"))
    expect_identical(object$id, 2L)

    object <- dplyr::filter(dataset, !facets_filter(sex, "label", "unknown"))
    expect_identical(object$id, 1L)

    object <- dplyr::filter(
        dataset,
        facets_filter(sex, "ontology_term_id", "PATO:0000384")
    )
    expect_identical(object$id, 1:2)

    object <- dplyr::filter(
        dataset,
        !facets_filter(sex, "ontology_term_id", "PATO:0000384")
    )
    expect_identical(object$id, integer())
})

test_that("db() works", {
    db_exists <- tryCatch({ db(); TRUE }, error = isTRUE)
    skip_if_not(db_exists)

    db <- db()
    expect_s3_class(db, c("cellxgene_db", "character"))
    expect_true(nzchar(db))
    json <- j_query(db, as = "R")
    expect_type(json, "list")
    expect_true(length(json) >= 48L)
})

---
title: "Discovery and retrieval"
author:
- name: Martin Morgan
  affiliation: Roswell Park Comprehensive Cancer Center
  email: Martin.Morgan@RoswellPark.org
package: cellxgenedp
output:
  BiocStyle::html_document
abstract: |
    The CELLxGENE data portal (https://cellxgene.cziscience.com/) provides a
    graphical user interface to collections of single-cell sequence data
    processed in standard ways to 'count matrix' summaries. The cellxgenedp
    package provides an alternative, R-based inteface, allowing flexible data
    discovery, viewing, and retrieval.
vignette: |
    %\VignetteIndexEntry{Discovery and retrieval}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---

NOTE: The interface to CELLxGENE has changed; versions of
[cellxgenedp][] prior to 1.4.1 / 1.5.2 will cease to work when
CELLxGENE removes the previous interface. See the vignette section
'API changes' for additional details.

# Installation and use

This package is available in _Bioconductor_ version 3.15 and
later. The following code installs [cellxgenedp][cellxgenedp-bioc]
from _Bioconductor_

[cellxgenedp-bioc]: https://bioconductor.org/packages/cellxgenedp
[cellxgenedp]: https://mtmorgan.github.io/cellxgenedp

```{r, eval = FALSE}
if (!"BiocManager" %in% rownames(installed.packages()))
    install.packages("BiocManager", repos = "https://CRAN.R-project.org")
BiocManager::install("cellxgenedp")
```

Alternatively, install the 'development' version from GitHub (see
[GitHub.io][cellxgenedp] for current documentation)

```{r, eval = FALSE}
if (!"remotes" %in% rownames(installed.packages()))
    install.packages("remotes", repos = "https://CRAN.R-project.org")
remotes::install_github("mtmorgan/cellxgenedp")
```

To also install additional packages required for this vignette, use

```{r, eval = FALSE}
pkgs <- c("tidyr", "zellkonverter", "SingleCellExperiment", "HDF5Array")
required_pkgs <- pkgs[!pkgs %in% rownames(installed.packages())]
BiocManager::install(required_pkgs)
```

Load the package into your current _R_ session. We make extensive use
of the dplyr packages, and at the end of the vignette use
SingleCellExperiment and zellkonverter, so load those as well.

```{r, message = FALSE}
library(zellkonverter)
library(SingleCellExperiment) # load early to avoid masking dplyr::count()
library(dplyr)
library(cellxgenedp)
```

# `cxg()` Provides a 'shiny' interface

The following sections outline how to use the [cellxgenedp][] package
in an _R_ script; most functionality is also available in the `cxg()`
shiny application, providing an easy way to identify, download, and
visualize one or several datasets. Start the app

```{r, eval = FALSE}
cxg()
```

choose a project on the first tab, and a dataset for visualization, or
one or more datasets for download!

# Collections, datasets and files

Retrieve metadata about resources available at the cellxgene data
portal using `db()`:

```{r}
db <- db()
```

Printing the `db` object provides a brief overview of the available
data, as well as hints, in the form of functions like `collections()`,
for further exploration.

```{r}
db
```

The portal organizes data hierarchically, with 'collections'
(research studies, approximately), 'datasets', and 'files'. Discover
data using the corresponding functions.

```{r}
collections(db)

datasets(db)

files(db)
```

Each of these resources has a unique primary identifier (e.g.,
`file_id`) as well as an identifier describing the relationship of the
resource to other components of the database (e.g.,
`dataset_id`). These identifiers can be used to 'join' information
across tables.

## Using `dplyr` to navigate data

A collection may have several datasets, and datasets may have several
files. For instance, here is the collection with the most datasets

```{r}
collection_with_most_datasets <-
    datasets(db) |>
    count(collection_id, sort = TRUE) |>
    slice(1)
```

We can find out about this collection by joining with the
`collections()` table.

```{r}
left_join(
    collection_with_most_datasets |> select(collection_id),
    collections(db),
    by = "collection_id"
) |> glimpse()
```

We can take a similar strategy to identify all datasets belonging to
this collection
```{r}
left_join(
    collection_with_most_datasets |> select(collection_id),
    datasets(db),
    by = "collection_id"
)
```

## `facets()` provides information on 'levels' present in specific columns

Notice that some columns are 'lists' rather than atomic vectors like
'character' or 'integer'.

```{r}
datasets(db) |>
    select(where(is.list))
```

This indicates that at least some of the datasets had more than one
type of `assay`, `cell_type`, etc. The `facets()` function provides a
convenient way of discovering possible levels of each column, e.g.,
`assay`, `organism`, `self_reported_ethnicity`, or `sex`, and the
number of datasets with each label.

```{r facets}
facets(db, "assay")
facets(db, "self_reported_ethnicity")
facets(db, "sex")
```

## Filtering faceted columns

Suppose we were interested in finding datasets from the 10x 3' v3
assay (`ontology_term_id` of `EFO:0009922`) containing individuals of
African American ethnicity, and female sex. Use the `facets_filter()`
utility function to filter data sets as needed

```{r african_american_female}
african_american_female <-
    datasets(db) |>
    filter(
        facets_filter(assay, "ontology_term_id", "EFO:0009922"),
        facets_filter(self_reported_ethnicity, "label", "African American"),
        facets_filter(sex, "label", "female")
    )
```

Use `nrow(african_american_female)` to find the number of datasets
satisfying our criteria. It looks like there are up to

```{r}
african_american_female |>
    summarise(total_cell_count = sum(cell_count))
```

cells sequenced (each dataset may contain cells from several
ethnicities, as well as males or individuals of unknown gender, so we
do not know the actual number of cells available without downloading
files). Use `left_join` to identify the corresponding collections:

```{r}
## collections
left_join(
    african_american_female |> select(collection_id) |> distinct(),
    collections(db),
    by = "collection_id"
)
```

## Publication and other external data

Many collections include publication information and other external
data. This information is available in the return value of
`collections()`, but the helper function `publisher_metadata()`,
`authors()`, and `links()` may facilitate access.

Suppose one is interested in the publication "A single-cell atlas of
the healthy breast tissues reveals clinically relevant clusters of
breast epithelial cells". Discover it in the collections

```{r}
title_of_interest <- paste(
    "A single-cell atlas of the healthy breast tissues reveals clinically",
    "relevant clusters of breast epithelial cells"
)
collection_of_interest <-
    collections(db) |>
    dplyr::filter(startsWith(name, title_of_interest))
collection_of_interest |>
    glimpse()
```

Use the `collection_id` to extract publisher metadata (including a DOI
if available) and author information

```{r}
collection_id_of_interest <- pull(collection_of_interest, "collection_id")
publisher_metadata(db) |>
    filter(collection_id == collection_id_of_interest) |>
    glimpse()
authors(db) |>
    filter(collection_id == collection_id_of_interest)
```

Collections may have links to additional external data, in this case a
DOI and two links to `RAW_DATA`.

```{r}
external_links <- links(db)
external_links
external_links |>
    count(link_type)
external_links |>
    filter(collection_id == collection_id_of_interest)
```

Conversely, knowledge of a DOI, etc., can be used to discover details
of the corresponding collection.

```{r}
doi_of_interest <- "https://doi.org/10.1016/j.stem.2018.12.011"
links(db) |>
    filter(link_url == doi_of_interest) |>
    left_join(collections(db), by = "collection_id") |>
    glimpse()
```

# Visualizing data in `cellxgene`

Visualization is straight-forward once `dataset_id` is available. For
example, to visualize the first dataset in `african_american_female`,
use

```{r, eval = FALSE}
african_american_female |>
    ## use criteria to identify a single dataset (here just the
    ## 'first' dataset), then visualize
    slice(1) |>
    datasets_visualize()
```

Visualization is an interactive process, so `datasets_visualize()`
will only open up to 5 browser tabs per call.

# File download and use

Datasets usually contain `H5AD` (files produced by the python AnnData
module), and `Rds` (serialized files produced by the _R_ Seurat
package). The `Rds` files may be unreadable if the version of Seurat
used to create the file is different from the version used to read the
file. We therefore focus on the `H5AD` files.

For illustration, we find all files associated with studies with
African American females

download one of our selected files.

```{r selected_files}
selected_files <-
    left_join(
        african_american_female |> select(dataset_id),
        files(db),
        by = "dataset_id"
    )
```

And then choose a single dataset and its H5AD file for download

```{r local_file_from_dataset_id}
local_file <-
    selected_files |>
    filter(
        dataset_id == "de985818-285f-4f59-9dbd-d74968fddba3",
        filetype == "H5AD"
    ) |>
    files_download(dry.run = FALSE)
basename(local_file)
```

These are downloaded to a local cache (use the internal function
`cellxgenedp:::.cellxgenedb_cache_path()` for the location of the
cache), so the process is only time-consuming the first time.

`H5AD` files can be converted to _R_ / _Bioconductor_ objects using
the [zellkonverter][] package.

```{r readH5AD}
h5ad <- readH5AD(local_file, use_hdf5 = TRUE, reader = "R")
h5ad
```

The `SingleCellExperiment` object is a matrix-like object with rows
corresponding to genes and columns to cells. Thus we can easily
explore the cells present in the data.

```{r}
h5ad |>
    colData(h5ad) |>
    as_tibble() |>
    count(sex, donor_id)
```

# Next steps

The [Orchestrating Single-Cell Analysis with Bioconductor][OSCA]
online resource provides an excellent introduction to analysis and
visualization of single-cell data in _R_ / _Bioconductor_. Extensive
opportunities for working with AnnData objects in _R_ but using the
native python interface are briefly described in, e.g., `?AnnData2SCE`
help page of [zellkonverter][].

[zellkonverter]: https://bioconductor.org/packages/zelkonverter
[OSCA]: https://bioconductor.org/books/OSCA

The [hca][] package provides programmatic access to the Human Cell
Atlas [data portal][HCAportal], allowing retrieval of primary as well
as derived single-cell data files.

[hca]: https://bioconductor.org/packages/hca
[HCAportal]: https://data.humancellatlas.org/explore

# API changes

Data access provided by CELLxGENE has changed to a new 'Discover'
[API][]. The main functionality of the [cellxgenedp][] package has not
changed, but specific columns have been removed, replaced or added, as
follows:

`collections()`

- Removed: `access_type`, `data_submission_policy_version`
- Replaced: `updated_at` replaced with `revised_at`
- Added: `collection_version_id`, `collection_url`, `doi`,
  `revising_in`, `revision_of`

`datasets()`

- Removed: `is_valid`, `processing_status`, `published`, `revision`,
  `created_at`
- Replaced: `dataset_deployments` replaced with `explorer_url`, `name`
  replaced with `title`, `updated_at` replaced with `revised_at`
- Added: `dataset_version_id`, `batch_condition`,
  `x_approximate_distribution`

`files()`

- Removed: `file_id`, `filename`, `s3_uri`, `user_submitted`,
  `created_at`, `updated_at`
- Added: `filesize`, `url`


[API]: https://api.cellxgene.cziscience.com/curation/ui/

# Session info {.unnumbered}

```{r sessionInfo, echo=FALSE}
sessionInfo()
```

---
title: "Case studies"
author:
- name: Martin Morgan
  affiliation: Roswell Park Comprehensive Cancer Center
  email: Martin.Morgan@RoswellPark.org
package: cellxgenedp
output:
  BiocStyle::html_document
abstract: |  
  This article summarizes short case studies and solutions arising
  from user queries.
vignette: >
  %\VignetteIndexEntry{Case studies}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

# Setup

For each case study, ensure that cellxgenedp (see the
[Bioconductor][cellxgenedp-bioc] package landing page, or
[GitHub.io][cellxgenedp] site) is installed (additional installation
options are at <https://mtmorgan.github.io/cellxgenedp/>).

[cellxgenedp-bioc]: https://bioconductor.org/packages/cellxgenedp
[cellxgenedp]: https://mtmorgan.github.io/cellxgenedp

```{r install, eval = FALSE}
if (!"BiocManager" %in% rownames(installed.packages()))
    install.packages("BiocManager", repos = "https://CRAN.R-project.org")
BiocManager::install("cellxgenedp")
```

Load the package.

```{r setup, message = FALSE}
library(cellxgenedp)
```

# Case study: authors & datasets

## Challenge and solution

This case study arose from a question on the CZI Science Community
Slack. A user asked

> Hi! Is it possible to search CELLxGENE and identify all datasets by
> a specific author or set of authors?

Unfortunately, this is not possible from the [CELLxGENE][] web site --
authors are only associated with collections, and collections can only
be sorted or filtered by title (or publication / tissue / disease /
organism).

[CELLxGENE]: https://cellxgene.cziscience.com/

A [cellxgenedp][] solution uses `authors()` to discover authors and
their collections, and joins this information to `datasets()`.

```{r}
author_datasets <- left_join(
    authors(),
    datasets(),
    by = "collection_id",
    relationship = "many-to-many"
)
author_datasets
```

`author_datasets` provides a convenient point from which to make basic
queries, e.g., finding the authors contributing the most datasets.

```{r}
author_datasets |>
    count(family, given, sort = TRUE)
```

Perhaps one is interested in the most prolific authors based on
'collections', rather than 'datasets'. The five most prolific authors
by collection are

```{r prolific authors}
prolific_authors <-
    authors() |>
    count(family, given, sort = TRUE) |>
    slice(1:5)
prolific_authors
```

The datasets associated with authors are

```{r prolific-author-datasets}
right_join(
    author_datasets,
    prolific_authors,
    by = c("family", "given")
)
```

Alternatively, one might be interested in specific authors.  This is
most easily accomplished with a simple filter on `author_datasets`, e.g.,

```{r specific-authors}
author_datasets |>
    filter(
        family %in% c("Teichmann", "Regev", "Haniffa")
    )
```

or more carefully by constructing at `data.frame` of family and given
names, and performing a join with `author_datasets`

```{r authors-of-interest}
authors_of_interest <-
    tibble(
        family = c("Teichmann", "Regev", "Haniffa"),
        given = c("Sarah A.", "Aviv", "Muzlifah")
    )
right_join(
    author_datasets,
    authors_of_interest,
    by = c("family", "given")
)
```

## Areas of interest

There are several interesting questions that suggest themselves, and
several areas where some additional work is required.

It might be interesting to identify authors working on similar
disease, or other areas of interest. The `disease` column in the
`author_datasets` table is a list.

```{r disease}
author_datasets |>
    select(family, given, dataset_id, disease)
```

This is because a single dataset may involve more than one
disease. Furthermore, each entry in the list contains two elements,
the `label` and `ontology_term_id` of the disease. There are two
approaches to working with this data.

One approach to working with this data uses facilities in
[cellxgenedp][] as outlined in an accompanying article. Discover
possible diseases.

```{r disease-facets}
facets(db(), "disease")
```

Focus on `COVID-19`, and use `facets_filter()` to select relevant
author-dataset combinations.

```{r disease-facet-filter}
author_datasets |>
    filter(facets_filter(disease, "label", "COVID-19"))
```

Authors contributing to these datasets are

```{r disease-facet-fitler-authors}
author_datasets |>
    filter(facets_filter(disease, "label", "COVID-19")) |>
    count(family, given, sort = TRUE)
```

A second approach is to follow the practices in [R for Data
Science][r4ds], the `disease` column can be 'unnested' twice, the
first time to expand the `author_datasets` table for each disease, and
the second time to separate the two columns of each disease.

```{r disease-unnest}
author_dataset_diseases <-
    author_datasets |>
    select(family, given, dataset_id, disease) |>
    tidyr::unnest_longer(disease) |>
    tidyr::unnest_wider(disease)
author_dataset_diseases
```

Author-dataset combinations associated with COVID-19, and contributors
to these datasets, are

```{r covid-19, eval = FALSE}
author_dataset_diseases |>
    filter(label == "COVID-19")

author_dataset_diseases |>
    filter(label == "COVID-19") |>
    count(family, given, sort = TRUE)
```

These computations are the same as the earlier iteration using
functionality in [cellxgenedp][].

A further resource that might be of interest is the [OSLr][] package
article illustrating how the ontologies used by CELLxGENE can be
manipulated to, e.g., identify studies with terms that derive from a
common term (e.g., all disease terms related to 'carcinoma').

[r4ds]: https://r4ds.hadley.nz/rectangling
[OLSr]: https://mtmorgan.github.io/OLSr/articles/

## Collaboration

TODO.

It might be interesting to know which authors have collaborated with
one another. This can be computed from the `author_datasets` table,
following approaches developed in the [grantpubcite][] package to
identify collaborations between projects in the NIH-funded ITCR
program. See the graph visualization in the [ITCR collaboration][]
section for inspiration.

[grantpubcite]: https://mtmorgan.github.io/grant
[ITCR collaboration]: https://mtmorgan.github.io/grantpubcite/articles/case_study_itcr.html#itcr-collaboration

## Duplicate collection-author combinations

Here are the authors

```{r}
authors <- authors()
authors
```

There are `r nrow(authors)` collection-author combinations. We expect
these to be distinct (each row identifying a unique collection-author
combination). But this is not true

```{r}
nrow(authors) == nrow(distinct(authors))
```

Duplicated data are

```{r}
authors |> 
    count(collection_id, family, given, consortium, sort = TRUE) |>
    filter(n > 1)
```

Discover details of the first duplicated collection,
`e5f58829-1a66-40b5-a624-9046778e74f5`

```{r}
duplicate_authors <-
    collections() |>
    filter(collection_id == "e5f58829-1a66-40b5-a624-9046778e74f5")
duplicate_authors
```
 The author information comes from the `publisher_metadata` column
 
```{r}
publisher_metadata <-
    duplicate_authors |>
    pull(publisher_metadata)
```

This is a 'list-of-lists', with relevant information as elements in
the first list

```{r}
names(publisher_metadata[[1]])
```

and relevant information in the `authors` field, of which there are 221

```{r}
length(publisher_metadata[[1]][["authors"]])
```

Inspection shows that there are four authors with family name `Pisco`
and given name `Angela Oliveira`: it appears that the data provided by
CZI indeed includes duplicate author names.

From a pragmatic perspective, it might make sense to remove duplicate
entries from `authors` before down-stream analysis.

```{r}
deduplicated_authors <- distinct(authors)
```

Tools that I have found useful when working with list-of-lists style
data rare [listviewer::jsonedit()][listviewer] for visualization, and
[rjsoncons][] for filtering and querying these data using JSONpointer,
JSONpath, or JMESpath expression (a more R-centric tool is the
[purrr][] package).

[listviewer]: https://CRAN.r-project.org/package=listviewer
[rjsoncons]: https://CRAN.r-project.org/package=rjsoncons
[purrr]: https://CRAN.r-project.org/package=purrr

### What is an 'author'?

The combination of family and given name may refer to two (or more)
different individuals (e.g., two individuals named 'Martin Morgan'),
or a single individual may be recorded under two different names
(e.g., given name sometimes 'Martin' and sometimes 'Martin T.'). It is
not clear how this could be resolved; recording ORCID identifiers
migth help with disambiguation.

# Case study: using ontology to identify datasets

This case study was developed in response to the following Slack
question:

> CELLxGENE's webpage is using different ontologies and displaying
> them in an easy to interogate manner (choosing amongst 3 possible
> coarseness for cell types, tissues and age) I was wondering if this
> simplified tree of the 3 subgroups for cell type, tissue and age
> categories was available somewhere?

As indicated in the question, CELLxGENE provides some access to
ontologies through a hand-curated three-tiered classification of
specific facets; the tiers can be retrieved from publicly available
code, but one might want to develop a more flexible or principled
approach.

CELLxGENE dataset facets like 'disease' and 'cell type' use terms from
ontologies. Ontologies arrange terms in directed acyclic graphs, and
use of ontologies can be useful to identify related datasets. For
instance, one might be interesed in cancer-related datasets (derived
from the 'carcinoma' term in the corresponding ontology) in general,
rather than, e.g., 'B-cell non-Hodgkins lymphoma'. 

In exploring this question in *R*, I found myself developing the
[OLSr][] package to query and process ontologies from the EMBL-EBI
[Ontology Lookup Service][OLS]. See the '[Case Study: CELLxGENE
Ontologies][OLSr-case-study]' article in the OLSr package for full
details.

[OLSr]:https://mtmorgan.github.io/OLSr
[OLS]: https://www.ebi.ac.uk/ols4/
[OLSr-case-study]: https://mtmorgan.github.io/OLSr/articles/b_case_study_cxg.html

# Session information {.unnumbered}

```{r sessionInfo, echo = FALSE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/db.R
\name{db}
\alias{db}
\title{Retrieve updated cellxgene database metadata}
\usage{
db(overwrite = .db_online() && .db_first())
}
\arguments{
\item{overwrite}{logical(1) indicating whether the database of
collections should be updated from the internet (the default,
when internet is available and, in an interactive session, the
user requests the update), or read from disk (assuming previous
successful access to the internet).  \code{overwrite = FALSE} might
be useful for reproducibility, testing, or when working in an
environment with restricted internet access.}
}
\value{
\code{db()} returns an object of class 'cellxgene_db',
summarizing available collections, datasets, and files.
}
\description{
Retrieve updated cellxgene database metadata
}
\details{
The database is retrieved from the cellxgene data portal
web site. 'collections' metadata are retrieved on each call;
metadata on each collection is cached locally for re-use.
}
\examples{
db()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/collections.R, R/datasets.R, R/files.R,
%   R/publisher_metadata.R
\name{collections}
\alias{collections}
\alias{datasets}
\alias{datasets_visualize}
\alias{files}
\alias{files_download}
\alias{links}
\alias{authors}
\alias{publisher_metadata}
\title{Query cellxgene collections, datasets, and files}
\usage{
collections(cellxgene_db = db())

datasets(cellxgene_db = db())

datasets_visualize(tbl)

files(cellxgene_db = db())

files_download(tbl, dry.run = TRUE, cache.path = .cellxgene_cache_path())

links(cellxgene_db = db())

authors(cellxgene_db = db())

publisher_metadata(cellxgene_db = db())
}
\arguments{
\item{cellxgene_db}{an optional 'cellxgene_db' object, as returned
by \code{db()}.}

\item{tbl}{a \code{tibble()} typically derived from \code{datasets(db)} or
\code{files(db)} and containing columns \code{dataset_id} (for
\code{datasets_visualize()}), or columns \code{dataset_id}, \code{file_id},
and \code{filetype} (for \code{files_download()}).}

\item{dry.run}{logical(1) indicating whether the (often large)
file(s) in \code{tbl} should be downloaded to a local cache. Files
are not downloaded when \code{dry.run = TRUE} (default).}

\item{cache.path}{character(1) directory in which to cache
downloaded files. The directory must already exist. The default
is \code{tools::R_user_dir("cellxgenedp", "cache")}, a
package-specific path in the user home directory.}
}
\value{
Each function returns a tibble describing the corresponding
component of the database.

\code{files_download()} returns a character() vector of paths to
the local files.

\code{links()} returns a tibble of external links associated
with each collection. Common links includ DOI, raw data / data
sources, and lab websites.

\code{authors()} returns a tibble of authors associated with
each collection.

\code{publisher_metadata()} returns a tibble of publisher
metadata (journal, publicate date, doi) associated with each
collection.
}
\description{
\code{files_download()} retrieves one or more cellxgene
files to a cache on the local system.

\code{links()}, \code{authors()} and \code{publisher_metadata()} are
helper functions to extract 'nested' information from
collections.
}
\examples{
db <- db()

collections(db)

collections(db) |>
    dplyr::glimpse()

datasets(db) |>
    dplyr::glimpse()

\donttest{
if (interactive()) {
    ## visualize the first dataset
    datasets(db) |>
        dplyr::slice(1) |>
        datasets_visualize()
}
}
files(db) |>
    dplyr::glimpse()

\dontrun{
files(db) |>
    dplyr::slice(1) |>
    files_download(dry.run = FALSE)
}

## common links to external data
links(db) |>
    dplyr::count(link_type)

## authors per collection
authors() |>
    dplyr::count(collection_id, sort = TRUE)

publisher_metadata() |>
    dplyr::glimpse()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cxg.R
\name{cxg}
\alias{cxg}
\title{Shiny application for discovering, viewing, and downloading
cellxgene data}
\usage{
cxg(as = c("tibble", "sce"))
}
\arguments{
\item{as}{character(1) Return value when quiting the shiny
application. \code{"tibble"} returns a tibble describing selected
datasets (including the location on disk of the downloaded
file). \code{"sce"} returns a list of dataset files imported to R as
SingleCellExperiment objects.}
}
\value{
\code{cxg()} returns either a tibble describing datasets
selected in the shiny application, or a list of datasets
imported into R as SingleCellExperiment objects.
}
\description{
Shiny application for discovering, viewing, and downloading
cellxgene data
}
\examples{
\donttest{
if (interactive())
    cxg()
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/facets.R
\docType{data}
\name{FACETS}
\alias{FACETS}
\alias{facets}
\alias{facets_filter}
\title{Facets available for querying cellxgene data}
\format{
\code{FACETS} is an object of class \code{character} of length 8.
}
\usage{
FACETS

facets(cellxgene_db = db(), facets = FACETS)

facets_filter(facet, key = c("label", "ontology_term_id"), value, exact = TRUE)
}
\arguments{
\item{cellxgene_db}{an (optional) cellxgene_db object, as returned
by \code{db()}.}

\item{facets}{a character() vector corersponding to one of the
facets in \code{FACETS}.}

\item{facet}{the column containing faceted information, e.g., \code{sex}
in \code{datasets(db)}.}

\item{key}{character(1) identifying whether \code{value} is a \code{label} or
\code{ontology_term_id}.}

\item{value}{character() value of the label or ontology term to
filter on. The value may be a vector with \code{length(value) > 0}
for exact matchs (\code{exact = TRUE}, default), or a \code{character(1)}
regular expression.}

\item{exact}{logical(1) whether values match exactly (default,
\code{TRUE}) or as a regular expression (\code{FALSE}).}
}
\value{
\code{facets()} returns a tibble with columns \code{facet}, \code{label},
\code{ontology_term_id}, and \code{n}, the number of times the facet
label is used in the database.

\code{facets_filter()} returns a logical vector with length
equal to the length (number of rows) of \code{facet}, with \code{TRUE}
indicating that the \code{value} of \code{key} is present in the dataset.
}
\description{
\code{FACETS} is a character vector of common fields used
to subset cellxgene data.

\code{facets()} is used to query the cellxgene database for
current values of one or all facets.

\code{facets_filter()} provides a convenient way to filter
facets based on label or ontology term.
}
\examples{
f <- facets()

## levels of each facet
f |>
    dplyr::count(facet)

## same as facets(, facets = "organism")
f |>
    dplyr::filter(facet == "organism")

db <- db()
ds <- datasets(db)

## datasets with African American females
ds |>
    dplyr::filter(
        facets_filter(self_reported_ethnicity, "label", "African American"),
        facets_filter(sex, "label", "female")
    )

## datasets with non-European, known ethnicity
facets(db, "self_reported_ethnicity")
ds |>
    dplyr::filter(
        !facets_filter(
            self_reported_ethnicity, "label", c("European", "na", "unknown")
        )
    )

}
\keyword{datasets}
